org.apache.lucene.search

## Class BlendedTermQuery

- java.lang.Object
- - org.apache.lucene.search.Query
  - - org.apache.lucene.search.BlendedTermQuery

    public final class BlendedTermQuery
    extends Query

A `Query` that blends index statistics across multiple terms. This is particularly useful when several terms should produce identical scores, regardless of their index statistics.

For instance imagine that you are resolving synonyms at search time, all terms should produce identical scores instead of the default behavior, which tends to give higher scores to rare terms.

An other useful use-case is cross-field search: imagine that you would like to search for `john` on two fields: `first_name` and `last_name`. You might not want to give a higher weight to matches on the field where `john` is rarer, in which case `BlendedTermQuery` would help as well.

WARNING: This API is experimental and might change in incompatible ways in the next release.

### Nested Class Summary

Nested Classes
`static class` `BlendedTermQuery.Builder` A Builder for `BlendedTermQuery`.
`static class` `BlendedTermQuery.DisjunctionMaxRewrite` A `BlendedTermQuery.RewriteMethod` that creates a `DisjunctionMaxQuery` out of the sub queries.
`static class` `BlendedTermQuery.RewriteMethod` A `BlendedTermQuery.RewriteMethod` defines how queries for individual terms should be merged.

### Field Summary

Fields
`static BlendedTermQuery.RewriteMethod` `BOOLEAN_REWRITE` A `BlendedTermQuery.RewriteMethod` that adds all sub queries to a `BooleanQuery`.
`static BlendedTermQuery.RewriteMethod` `DISJUNCTION_MAX_REWRITE` `BlendedTermQuery.DisjunctionMaxRewrite` instance with a tie-breaker of `0.01`.

### Method Summary

All Methods Instance Methods Concrete Methods
`boolean` `equals(Object other)` Override and implement query instance equivalence properly in a subclass.
`int` `hashCode()` Override and implement query hash code properly in a subclass.
`Query` `rewrite(IndexReader reader)` Expert: called to re-write queries into primitive queries.
`String` `toString(String field)` Prints a query to a string, with `field` assumed to be the default field and omitted.
`void` `visit(QueryVisitor visitor)` Recurse through the query tree, visiting any child queries

### Methods inherited from class org.apache.lucene.search.Query

`classHash, createWeight, sameClassAs, toString`

### Methods inherited from class java.lang.Object

`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

### Field Detail

#### BOOLEAN_REWRITE

    public static final BlendedTermQuery.RewriteMethod BOOLEAN_REWRITE

A `BlendedTermQuery.RewriteMethod` that adds all sub queries to a `BooleanQuery`. This `BlendedTermQuery.RewriteMethod` is useful when matching on several fields is considered better than having a good match on a single field.

#### DISJUNCTION_MAX_REWRITE

    public static final BlendedTermQuery.RewriteMethod DISJUNCTION_MAX_REWRITE

`BlendedTermQuery.DisjunctionMaxRewrite` instance with a tie-breaker of `0.01`.

### Method Detail

#### equals

    public boolean equals(Object other)

Description copied from class: `Query`
Override and implement query instance equivalence properly in a subclass. This is required so that `QueryCache` works properly. Typically a query will be equal to another only if it's an instance of the same class and its document-filtering properties are identical that other instance. Utility methods are provided for certain repetitive code.

Specified by:
  `equals` in class `Query`
See Also:
  `Query.sameClassAs(Object)`, `Query.classHash()`

#### hashCode

    public int hashCode()

Description copied from class: `Query`
Override and implement query hash code properly in a subclass. This is required so that `QueryCache` works properly.

Specified by:
  `hashCode` in class `Query`
See Also:
  `Query.equals(Object)`

#### toString

    public String toString(String field)

Description copied from class: `Query`
Prints a query to a string, with `field` assumed to be the default field and omitted.

Specified by:
  `toString` in class `Query`

#### rewrite

    public final Query rewrite(IndexReader reader)
                        throws IOException

Description copied from class: `Query`
Expert: called to re-write queries into primitive queries. For example, a PrefixQuery will be rewritten into a BooleanQuery that consists of TermQuerys.

Overrides:
  `rewrite` in class `Query`
Throws:
  `IOException`

#### visit

    public void visit(QueryVisitor visitor)

Description copied from class: `Query`
Recurse through the query tree, visiting any child queries

Overrides:
  `visit` in class `Query`
Parameters:
  `visitor` - a QueryVisitor to be called by each query in the tree